package moreswing.swing.i18n

import scala.swing.Action

/** Extends [[scala.swing.Action]] with localization support.
 *
 * @author myst3r10n
*/
trait LAction extends Action with LocaleListener {

  private var titleKey = super.title
  private var toolTipKey: String = null

  /** Add listener to [[scala.swingx.i18n.LocaleManager]]. */
  LocaleManager += this

  /** Called by [[scala.swingx.i18n.LocaleManager]] if locale changed. */
  def localeChanged {

    title = titleKey

    if(toolTipKey != null)
      toolTip = toolTipKey

  }

  /** Set title. */
  override def title_= (s: String) {

    this.titleKey = s
    super.title = LocaleManager.text(titleKey)

  }

  /** Set toolTip. */
  override def toolTip_= (t: String) {

    this.toolTipKey = t
    super.toolTip = LocaleManager.text(toolTipKey)

  }

}
