package moreswing.swing.i18n

import scala.swing.CheckBox

/** It's [[scala.swing.CheckBox]] with localization support.
 *
 * @author myst3r10n
*/
trait LCheckBox extends CheckBox with LocaleListener {

  private var textKey = peer.getText
  private var tooltipKey: String = null

  /** Add listener to [[scala.swingx.i18n.LocaleManager]]. */
  LocaleManager += this

  /** Called by [[scala.swingx.i18n.LocaleManager]] if locale changed. */
  def localeChanged {

    text = textKey

    if(tooltipKey != null)
      tooltip = tooltipKey

  }

  /** Set text. */
  override def text_= (s: String) {

    this.textKey = s
    peer.setText(LocaleManager.text(textKey))

  }

  /** Set tooltip. */
  override def tooltip_= (t: String) {

    this.tooltipKey = t
    super.tooltip = LocaleManager.text(tooltipKey)

  }
}

